class SBIIf
    @ifnum
    @epin
    @epout

    def initialize *args
        raise ArgumentError, 'function shall accept 0, 1 or 3 arguments' unless [0, 1, 3].include? args.count

        @ifnum, @epin, @epout = 0, 0, 0

        if args.count == 1
            _args = args[0].to_s.split ':'

            raise ArgumentError, "Invalid string format of vid:pid - #{args[0].to_s}" if _args.count != 3

            args = _args
        end

        if args.count == 3
            self.ifnum = args[0]
            self.epin = args[1]
            self.epout = args[2]
        end
    end

    def ifnum 
        @ifnum
    end

    def epin
        @epin
    end

    def epout
        @epout
    end

    def ifnum= (n)
        @ifnum = n.to_i
    end

    def epin= (n)
        raise ArgumentError, 'Invalid endpoint number' if n.to_i > 0xFF || n.to_i&0x7F > 16

        @epin = n.to_i&0x7F
    end

    def epout= (n)
        raise ArgumentError, 'Invalid endpoint number' if n.to_i > 0xFF || n.to_i&0x7F > 16

        @epout = n.to_i&0x7F
    end

    def to_s
        "#{@ifnum.to_s}:#{@epin.to_s}:#{@epout.to_s}"
    end
end
